#!/bin/tcsh -f
#

echo " "

set count=`/bin/ps uxww | /usr/bin/grep -v grep | /usr/bin/grep -c XDarwin`
set count=0
if( $count != 0 ) then
  echo "XDarwin is currently running -"
  echo "please exit it before using this script"
  sleep 1
  exit 12
endif

set thisdir=`echo $0 | /usr/bin/sed 's/InterleaveX11.command//'`

if( ! -d "$thisdir" ) then
  echo "Could not find OroborOSX directory"
  echo "  -assuming run from command line?"
  sleep 1
else
  cd $thisdir
endif

if( ! -d /Applications ) then
  echo "The Applications directory is missing"
  echo " -aborting attempt to set up XDarwin"
  sleep 1
  exit 10
endif

if( ! -d /Applications/XDarwin.app ) then
  echo "Cannot find the XDarwin application"
  echo " -aborting attempt to set up XDarwin"
  sleep 1
  exit 2
endif

if( ! -e /Applications/XDarwin.app/Contents/Info.plist ) then
  echo "Cannot find XDarwin's Info.plist file"
  echo " -aborting attempt to set up XDarwin"
  sleep 1
  exit 3
endif

if( ! -e Info-new.plist ) then
  echo "Cannot find new Info.plist for XDarwin"
  echo " -aborting attempt to set up XDarwin"
  sleep 1
  exit 4
endif

set count=`/usr/bin/grep -i -c nsuielement /Applications/XDarwin.app/Contents/Info.plist`

if( $count == 1 ) then
  echo "XDarwin looks like it is already"
  echo "updated for window interleaving"
  echo " -no need to do anything"
  sleep 1
  exit
endif

/usr/bin/sudo -k
if( $#argv == 0 ) then
  echo "In order to change XDarwin"
  echo "to interleave X11 windows,"
  echo "I need Administrator access."
  echo " "
  echo "Type your password and press return"
  /usr/bin/sudo mv /Applications/XDarwin.app/Contents/Info.plist /Applications/XDarwin.app/Contents/Info-org.plist
else
  echo $1 | /usr/bin/sudo -p "" -S mv /Applications/XDarwin.app/Contents/Info.plist /Applications/XDarwin.app/Contents/Info-org.plist 
endif

echo " "

if( ! -e /Applications/XDarwin.app/Contents/Info-org.plist ) then
   echo "Failed to move original Info.plist"
   sleep 1
   exit 5
endif

/usr/bin/sudo cp Info-new.plist /Applications/XDarwin.app/Contents/Info.plist

if( ! -e /Applications/XDarwin.app/Contents/Info.plist ) then
   echo "Failed to create new Info.plist..."
   /usr/bin/sudo mv /Applications/XDarwin.app/Contents/Info-org.plist /Applications/XDarwin.app/Contents/Info.plist
   sleep 1
   exit 6
endif

set count=`/usr/bin/grep -i -c nsuielement /Applications/XDarwin.app/Contents/Info.plist`

if( $count != 1 ) then
  echo "Something went wrong"
  echo " - failed to change XDarwin's Info.plist"
  sleep 1
  exit 7
endif

echo "XDarwin successfully updated"
echo " -window interleaving now enabled"
sleep 1
